/*
 * 
 * Autor: Víctor Muñoz Higuero
 * 
 */

package processing.test.joc_processing;

import processing.core.PApplet;
import processing.core.PImage;
import processing.core.PVector;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;

/*
 * 
 * Classe Joc (classe principal) 
 * És la primera en executar i s'encarrega de llençar el menu principal i a mes de
 * genera i construir el joc.  
 * 
 */
public class Joc extends PApplet {

PImage punt;

// variables per dibuixar les fletxes de control
float xEsquerra;
float yEsquerra;
int tamanyEsquerra = 150;
float xDreta;
float yDreta;
int tamanyDreta = 150;
float xAmunt;
float yAmunt;
int tamanyAmunt = 850;

// boolea per comprovar si em rebut una nova pantalla
boolean checkNovaPantalla = false;
//Graella auxiliar per la pantalla de joc
int [][]graellaAuxiliar = null;
// Graella amb la pantalla inicial de joc
int[][] graellaInicis = new int[60][97];
// instancia de la classe jugador 
Jugador jugador1 = new Jugador();
// instancia de la classe pantalla
Pantalla mon = new Pantalla();
// booleans per controlar si s'esta picant una de les tecles de control
Boolean manteAmunt=false;
Boolean manteDreta=false;
Boolean manteEsquerra=false;
// variable per fixar la gravetat 
final float GRAVETAT = 1.0f;
final Context context = this;

public int sketchWidth() { return 1150; }
public int sketchHeight() { return 714; }


/*
 * 
 * Main de la classe Joc.
 * Processing la crida automàticament al executar-se el programa
 *   
 */

public void setup() { 
	
	for(int iIn = 0; iIn < graellaInicis.length;iIn++)
		for(int jIn=0;jIn< graellaInicis[0].length;jIn++){
			graellaInicis[iIn][jIn] = 0;
			
		}
	
   // En aquest punt iniciem l'Activity encarregada d'executar la classe Processat. 
   // Aquesta crida fa apareixer la pantalla inicial de laplicacio.
  Intent intent = new Intent(context, Processat.class);
  startActivityForResult(intent,1);  

  // Carreguem la imatge del jugador. 
  punt = loadImage("punt.png");

  // Definim el refresc del joc. 30 vegades per segon
  frameRate(30);
  resetGame();
  
  // Definim les coordenades on colocarem les tecles de control.
  xEsquerra = 0;
  yEsquerra = height - tamanyDreta;
  xDreta = width - (tamanyDreta) ;
  yDreta = height - (tamanyDreta);
  xAmunt = (0 + tamanyDreta);
  yAmunt = height - tamanyAmunt;
  
}


/*
 * 
 * Funció per tractar la donada per la Activity que llença la classe Processat
 * La funció es cridada quan l'Activity processat finalitza.  
 */
@Override
protected void onActivityResult(int requestCode, int resultCode, Intent i){
		if(resultCode == Activity.RESULT_OK){			
			// Rebem la resposta de la Activity
			Bundle bun  = new Bundle();
			bun = (Bundle) i.getExtras().getBundle("text");

			// La rebem com un object
			Object[] objecteRebut = (Object[]) bun.getSerializable("arrayPantalla");
			
			//Convertim l'objecte a un vector 2D amb la mida de la futura pantalla de joc
			if(objecteRebut!=null){
				graellaAuxiliar = new int[objecteRebut.length][];
				for(int j=0;j<objecteRebut.length;j++){
					graellaAuxiliar[j] = (int[])objecteRebut[j];
				}
			}	
			
			this.graellaInicis = graellaAuxiliar;
			
			// Fiquem a true el bolea que controla que hem rebut una nova pantalla.
			checkNovaPantalla = true;
		}	
}

/*
 * 
 * Funció que fa un reseteig de tota la partida.
 * 
 */
public void resetGame() {
  // Reset de la partida
  mon.recarrega(); 
}

/*
 * 
 * Funció que encarregada de pintar tots els elements a la pantalla.  
 * Processing la crida automàticament al executar-se el programa
 * 
 */


public void draw() {
  if(checkNovaPantalla){
	  resetGame();
	  checkNovaPantalla = false;
  }
  
  pushMatrix();
  mon.renderitza();
  jugador1.comprovaAccio();
  jugador1.enMoviment();
  jugador1.dibuixaJugador();
  popMatrix();
  fill(153);
  
  // Configuració i pintat del control esquerra  
 if (mouseX > xEsquerra && mouseX < xEsquerra+tamanyEsquerra && 
    mouseY > yEsquerra && mouseY < yEsquerra+tamanyEsquerra && mousePressed) {
	manteEsquerra = true; 
  }   
  
  else {
    manteEsquerra = false;
  }  
 
 fill(255,0,0,175);
 rect(xEsquerra+(tamanyEsquerra/2), height - (tamanyEsquerra/1.63f), (tamanyEsquerra)/2, (tamanyEsquerra/2)/2);
 triangle(0,height-((tamanyEsquerra)/2), 0+(tamanyEsquerra/2), height, 0+(tamanyEsquerra/2), height - (tamanyEsquerra));

  // Configuració i pintat del control dret

  if (mouseX > xDreta && mouseX < xDreta+tamanyDreta && 
    mouseY > yDreta && mouseY < yDreta+tamanyDreta && mousePressed) {
	manteDreta = true;  
  } 
  else {    
    manteDreta = false;
  }
  
  fill(255,0,0,175);
  rect(width - (tamanyDreta), height - (tamanyDreta/1.63f), (tamanyDreta)/2, (tamanyDreta/2)/2);
  triangle(width - (tamanyDreta/2),height-(tamanyDreta), width - (tamanyDreta/2), height, width, height - (tamanyDreta)/2);

  // Configuració del control amunt (saltar)
  if (mouseX > xAmunt && mouseX < xAmunt+tamanyAmunt && 
    mouseY > yAmunt && mouseY < yAmunt+tamanyAmunt && mousePressed) {
	manteAmunt = true;  
    
  } 
  else {
	manteAmunt = false;
  }

 
  
 
}

/*
 * Funcio per parar el joc. 
 * Aquesta funció es crida quan el usuari guanya la partida i acaba el joc. 
 * 
 */

public void stop() { 
  super.stop();
}

/*
 *
 * 
 * Inner Class Jugador.
 * 
 * Conté la configuració i física del jugador. 
 * 
 * 
 */
class Jugador {
  PVector coordPosicio,coordVelocitat;  
  //boolea per controlar si el jugador trepitja terra
  Boolean esATerra; 
   
  /*
   * Métode constructor de la classe jugador. 
   * 
   */
  Jugador() { 
    esATerra = false;
    coordPosicio = new PVector();
    coordVelocitat = new PVector();
  }
  
  /*
   * Funcio encarregada de la física del jugador.(salt, velocitat, fricció..)
   * 
   */
  public void comprovaAccio() {
	// potencia de salt del jugador
	final float potenciaSalt = 10.0f;
	// velocitat de moviment pixels/cicle
	final float velocitatTerra = 3.0f;  
	// velocitat de moviment al aire
	final float velocitatAire = 2.0f;	
	//velocitat al instant
    float velocitatInstant = (esATerra ? velocitatTerra : velocitatAire);
    
    // Actualització la coordenada de velocitat.
    if(manteEsquerra) {
      coordVelocitat.x -= velocitatInstant;
    } else if(manteDreta) {
      coordVelocitat.x += velocitatInstant;
    } 
    // Afegim friccio al desplaçament sobre terra reduint la velocitat.  
    coordVelocitat.x = coordVelocitat.x * 0.85f; 
    
    // Logica de salt del jugador. Salta si es sobre terra
    // i redueix la força del salt a mesura que puja. 
    if(esATerra) { 
      if(manteAmunt) {          
        coordVelocitat.y = -potenciaSalt; 
        esATerra = false; 
      }
    }
  }
  
  /*
   * Funcio encarregada de la lógica del jugador.
   * (colisions, zones de mort, zona de fi de joc,... )
   * 
   */
  public void comprobaColisions() {
	// amplada del jugador
	int ampladaJugador = punt.width;
    // alçada del jugador
    int alcadaJugador = punt.height;
    PVector superiorEsquerra,superiorDret, inferior;
    superiorEsquerra = new PVector();
    superiorDret = new PVector();
    inferior = new PVector();    
    // coordenades de la part superior esquerra del Jugador
    superiorEsquerra.x = coordPosicio.x-ampladaJugador/4; 
    superiorEsquerra.y = coordPosicio.y-alcadaJugador;
    // coordenades de la part superior dreta del Jugador
    superiorDret.x = coordPosicio.x+ampladaJugador/4;
    superiorDret.y = coordPosicio.y-alcadaJugador;
    // coordenades de la part inferior del Jugador
    inferior.x = coordPosicio.x;
    inferior.y = coordPosicio.y + alcadaJugador/2;
        
    // Comprobem si el jugador esta en zona de foc i ha de morir i començar de nou la partida. 
    if( mon.identificaCasella(superiorEsquerra)==Pantalla.casellaFoc ||mon.identificaCasella(superiorEsquerra)==Pantalla.casellaFoc || mon.identificaCasella(coordPosicio)==Pantalla.casellaFoc || mon.identificaCasella(inferior)==Pantalla.casellaFoc) {
    	resetGame();
    }
    // Comprobem si el jugador esta en zona de fi de joc i s'ha de para el joc i avisar que ha guanyat.     
    if( mon.identificaCasella(superiorEsquerra)==Pantalla.cassellaMeta ||mon.identificaCasella(superiorEsquerra)==Pantalla.cassellaMeta || mon.identificaCasella(coordPosicio)==Pantalla.cassellaMeta) {
        stop();
        
        fill(0, 0, 0, 250);
        rect(0,0,1150,714);
        textSize(42);
        fill(0, 150, 0, 220);
        text("Enhorabona, has guanyat el joc! \nCongratulations, you have won the game!", width/8,height/2);
      }
    
    // Comprobem si hi ha colisions amb parets o terra. 
    if( (mon.identificaCasella(superiorEsquerra)==Pantalla.cassellaMur) || (mon.identificaCasella(superiorDret)==Pantalla.cassellaMur)){
      if(mon.identificaCasella(coordPosicio)==Pantalla.cassellaMur) {

        coordVelocitat.x=0.0f;
        coordVelocitat.y=0.0f;
      } else {
        if(coordVelocitat.y < 0) {
          coordVelocitat.y = 0.0f;
        }
      }
    }
  }

  /*
   * Funcio encarregada de la física a les caigudes.
   * 
   */
  public void comprobaCaiguda() {
    
	  if(esATerra==false) {    
      if(mon.identificaCasella(coordPosicio)==Pantalla.cassellaMur) { 
        esATerra = true;
        coordVelocitat.y = 0.0f;
      } else {
        coordVelocitat.y += GRAVETAT;
      }
    }
    
    if(mon.identificaCasella(coordPosicio)==Pantalla.cassellaBuida) {
        esATerra=false;
     }
  }
  
  /*
   * Funcio encarregada de moure el jugador i cridar les funcions de 
   * logica del joc i fisica de les caigudes.  
   * 
   */
  
  public void enMoviment() {
    coordPosicio.add(coordVelocitat);    
    comprobaColisions();    
    comprobaCaiguda();
  }
  
  /*
   * Funcio de pintat del jugador 
   */
  
  public void dibuixaJugador(){
    int ampladaJugador= punt.width;
    int alcadaJugador = punt.height;
    pushMatrix(); 
    translate(coordPosicio.x,coordPosicio.y);
    translate(-ampladaJugador/2,-alcadaJugador);
    image(punt, 0,0);
    popMatrix(); 
  }
}

/*
*
* 
* Inner Class Pantalla.
* 
* Conté la configuració de la pantalla. 
* 
* 
*/


class Pantalla {	
  // tamany en pixels de cada la casella
  static final int pixelsCasella = 12;
  // ample de la matriu pantalla
  static final int ampleGraella = 97;
  // alt de la matriu pantalla
  static final int altGraella = 60; 
  // cassella sense res
  static final int cassellaBuida = 0; 
  // cassella solida (mur)
  static final int cassellaMur = 1;   
  // casella on comenca a jugar el jugador
  static final int cassellaInici = 4; 
  // la casella on acaba la partida el jugador
  static final int cassellaMeta = 7;
  // casella zona de mort del jugador. Quan passa per ella mor i torna a començar la partida
  static final int casellaFoc = 9; 

  // vector 2D que contindra la pantalla
  int[][] worldGrid = new int[altGraella][ampleGraella];
  
/*
 * Funcio indicadora del tipus de casella que hi ha a la posicio donada.
 *  
 */
  
  public int identificaCasella(PVector coordActualPosicio) {
    float coordX = coordActualPosicio.x/pixelsCasella;
    float coordY = coordActualPosicio.y/pixelsCasella;
  
    if(coordX<0) {
      return cassellaMur; 
    }
    if(coordX>=ampleGraella) {
      return cassellaMur; 
    }
    if(coordY<0) {
      return cassellaMur; 
    }
    if(coordY>=altGraella) {
      return cassellaMur;
    }
    
    return worldGrid[PApplet.parseInt(coordY)][PApplet.parseInt(coordX)];
  }
   
  /*
   * Funció que reseteja la partida i coloca al jugador de nou a la posicio inicial
   * 
   */
   public void recarrega() {	
    for(int i=0;i<ampleGraella;i++) {
      for(int ii=0;ii<altGraella;ii++) {
        if(graellaInicis[ii][i] == cassellaInici) {
          worldGrid[ii][i] = cassellaBuida; 
          // colocar al jugador al centre de la casella
          jugador1.coordPosicio.x = i*pixelsCasella+(pixelsCasella/2);
          jugador1.coordPosicio.y = ii*pixelsCasella+(pixelsCasella/2);
        } else {
          worldGrid[ii][i] = graellaInicis[ii][i];
        }
      }
    }
  }
   
/* 
 * Funció encarregada de pintar les caselles del joc en funció del tipus de casella.
 * 
 */
  public void renderitza() { 
    for(int i=0;i<ampleGraella;i++) { 
      for(int ii=0;ii<altGraella;ii++) {
    	// comprobem quin tipus de casella es  
        switch(worldGrid[ii][i]) {
          // si es una casella solida (mur, terra)
          case cassellaMur: 
        	  stroke(163,163,163); 
              fill(92,92,92);
            break;
          // si es una casella de mort    
          case casellaFoc:
              stroke(255,0,0);
              fill(255,0,0);
              break;
          // si es una casella de fi de joc     
          case cassellaMeta:
              stroke(0,0,255); 
              fill(0,0,255);             
              break;
          default:
            stroke(255); 
            fill(255); 
            break;
        }
        
        rect(i*pixelsCasella,ii*pixelsCasella, pixelsCasella-1,pixelsCasella-1);
      }
    }
  }
  
}

}
