/*
 * 
 * Autor: Víctor Muñoz Higuero
 * 
 */


package processing.test.joc_processing;

import java.io.File;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.Matrix;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.os.Parcelable;
import android.provider.MediaStore;
import android.view.Menu;
import android.view.View;
import android.widget.ImageButton;
import android.widget.Toast;


public class Processat extends Activity{
	// boto Play
	ImageButton btnCalcu;
	// boto Capture
	ImageButton btnCaptura;
	// Intent de la camera
	Intent takePictureIntent;
	// Bitmap de la foto feta per l'usuari
	Bitmap mImageBitmap;
	// directori per guardar la fotografia feta
	private File directori;
	// directori per la fotografia feta
    private Uri uriFitxerSortida;
    
	
	/*
	 * Metode cridat al executarse la Activity 
	 * 
	 * */
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		mainProcessamentColors();		
	}
	
	/*
	 * Funcio de processat de la imatge
	 * */
	public void mainProcessamentColors(){
		
		// Configuració del boto "Capture"
		setContentView(R.layout.activity_colors);
        btnCaptura = (ImageButton)findViewById(R.id.button2);
        btnCaptura.setOnClickListener(new ImageButton.OnClickListener() {    	        	
    		public void onClick(View v) { 			
    			// crea el directori per guardar la imatge que es farà
    			creaDirectoriFotos();
    			// crida a la funció encarregada de fer aparéixer la càmera del dispositiu
    			intentObrirImatge();
    		}});
        
        // Configuració del boto "Play" que s'encarrega del processat i creacio d'una nova pantalla
        
		btnCalcu = (ImageButton)findViewById(R.id.button1);		   
    	btnCalcu.setOnClickListener(new ImageButton.OnClickListener() {
    		
    		public void onClick(View v) {
    			InputStream is = null;    			
    			Bitmap bitmap = null; 
    			
    			// Carreguem la foto des de la memoria interna comprovant que s'hagi feta
    			try {
					is = getContentResolver().openInputStream(uriFitxerSortida);
				}
    			
    			// En el cas que no s'hagi fet la foto mostrem avis al usuari
    			catch (Exception e) {
					
					Context context1 = getApplicationContext();
					CharSequence text = "Fes primer la foto de la pantalla! \n First take the picture of the game screen! ";
					int duration = Toast.LENGTH_LONG;

					Toast toast = Toast.makeText(context1, text, duration);
					toast.show();
					
					return;
				}
    			
    			// convertim la imatge feta a Bitmap
    			bitmap = BitmapFactory.decodeStream(is);   		
    			
    			// Coloquem la fotografia en posició horitzontal
    			Bitmap rotat = rotarBitmap(bitmap,270f);
    			
    			// Reduim la resolució de la fotografia
    			Bitmap bmpReduit = redimensionarImatge(rotat, 60, 97);
    			bitmap = bmpReduit;

				int height = bitmap.getHeight();
				int width = bitmap.getWidth();
				int[][]foto = new int[width][height];				
				int w = 0;
				int h = 0;
				
				// Fiquem en un vector 2D la imatge				
				for(w = 0; w<=width-1; w++){
					for(h = 0; h<=height-1; h++){						
							foto[w][h]=bitmap.getPixel(w, h);						
					}
				}
												
				//vector 2D  pel binari del color negre
				int[][]binariNegre = new int[width][height]; 
				//vector 2D  pel binari del color vermell
				int[][]binariVermell = new int[width][height];
				//vector 2D  pel binari del color blau
				int[][]binariBlau = new int[width][height]; 
				//vector 2D  pelbinari del color verd
				int[][]binariVerd = new int[width][height];
				
				
				// a continuació recorrem la imatge i anem realitzant la segmentació 
				//i binarització de cada color
				
				for(w = 0; w<=width-1; w++){
					for(h = 0; h<=height-1; h++){
							int pixel = bitmap.getPixel(w, h);
							float[]hsvPixel = new float[3];
							Color.colorToHSV(pixel, hsvPixel);
							// en el cas que el pixel sigui negre fiquem un 1 al vector del negre
							// i 0 a la resta
							if(esNegre(hsvPixel)){
								binariVermell[w][h]=binariBlau[w][h]=binariVerd[w][h]=0;
								binariNegre[w][h]=1;
							}
							
							// en el cas que el pixel sigui vermell fiquem un 1 al vector del vermell
							// i 0 a la resta
							else if(esVermell(hsvPixel)){
								binariNegre[w][h]=binariBlau[w][h]=binariVerd[w][h]=0;
								binariVermell[w][h]=1;
							}
							
							// en el cas que el pixel sigui blau fiquem un 1 al vector del blau
							// i 0 a la resta
							else if(esBlau(hsvPixel)){
								binariNegre[w][h]=binariVermell[w][h]=binariVerd[w][h]=0;
								binariBlau[w][h]=1;
								
							}
							
							// en el cas que el pixel sigui verd fiquem un 1 al vector del verd
							// i 0 a la resta
							else if(esVerd(hsvPixel)){
								binariNegre[w][h]=binariVermell[w][h]=binariBlau[w][h]=0;
								binariVerd[w][h]=1;
							}
							
							// en cas que el pixel no sigui dels altres colors fiquem 0 a tots els vectors
							else{
								binariNegre[w][h]=binariVermell[w][h]=binariBlau[w][h]=binariVerd[w][h]=0;
							}
					}
				}
				
				// vector 2D on farem la unió de colors per formar una unic vector
				// que tingui la informacio de tots els colors
				int vectorPantalla [][] = null;
				
				//afegim la informació del negre (un 1 a la posicio on hi hagi negre)
				vectorPantalla = binariNegre;
				
				//afegim la informació del verd (un 4 a la posicio on hi hagi verd)
				for(int iVerd = 0; iVerd < binariVerd.length;iVerd++){
					for(int jVerd=0;jVerd< binariVerd[0].length;jVerd++){
						if(binariVerd[iVerd][jVerd] == 1){
							vectorPantalla[iVerd][jVerd] = 4; 
						}
					}
				}
				
				//afegim la informació del blau (un 7 a la posicio on hi hagi blau)
				for(int iBlau = 0; iBlau < binariBlau.length;iBlau++){
					for(int jBlau=0;jBlau< binariBlau[0].length;jBlau++){
						if(binariBlau[iBlau][jBlau] == 1){
							vectorPantalla[iBlau][jBlau] = 7; 
						}
					}
				}
				
				//afegim la informació del vermell (un 4 a la posicio on hi hagi vermell)
				for(int iVermell = 0; iVermell < binariVermell.length;iVermell++){
					for(int jVermell=0;jVermell< binariVermell[0].length;jVermell++){
						if(binariVermell[iVermell][jVermell] == 1){
							vectorPantalla[iVermell][jVermell] = 9; 
						}
					}
				}
				
				
				
				  
				// Intent per l'Enviament de la resposta a l'Activity pare
				Intent i = new Intent();				
				Bundle mBundle = new Bundle();

				// Enviem l'array pantalla creat abans que conte les dades de la pantalla, posicio inicial, ...
				mBundle.putSerializable("arrayPantalla", vectorPantalla);
		        i.putExtra("text",mBundle);
		        setResult(Activity.RESULT_OK,i);

		        // Finalitzem la Activity per tornar a la Activity pare (Joc)
		    	Processat.this.finish();
				
    			} 
    		} );

	}
	

	/*
	 * Funció de rotació d'imatges Bitmap
	 * 
	 */
	public Bitmap rotarBitmap(Bitmap original, float angle){
		// Creem una matriu per la manipulació
		Matrix matriu = new Matrix();
		//Rotem la matriu
		matriu.preScale(-1, 1);
		matriu.postRotate(angle);
		// Creem el nou Bitmap
		Bitmap bitmapRotat = Bitmap.createBitmap(original, 0, 0, original.getWidth(), original.getHeight(), matriu, true);
		return bitmapRotat;
	}
	
	/*
	 * Funció de redimensió d'imatges Bitmap
	 * 
	 */
	public Bitmap redimensionarImatge(Bitmap mBitmap, float novaAmplada, float novaAlcada){
		int amplada = mBitmap.getWidth();
		int alcada = mBitmap.getHeight();
		float ampladaEscalada = ((float) novaAmplada) / amplada;
		float altEscalada = ((float) novaAlcada) / alcada;
		// Creem una matriu per la manipulació
		Matrix matriu = new Matrix();
		// Redimensionem la matriu
		matriu.postScale(ampladaEscalada, altEscalada);
		// retornem el nou Bitmap
		Bitmap bitmapReduit = Bitmap.createBitmap(mBitmap, 0, 0, amplada, alcada, matriu, false); 
		return bitmapReduit;
	}
	
	/*
	 * Funció per comprobar si el color indicat es considera negre
	 * 
	 */
	public boolean esNegre(float[]hsv){
		boolean isColor = false;
		if(hsv[2] <= 0.25){
			isColor=true;
		}		
		return isColor; 
	}
	
	/*
	 * Funció per comprobar si el color indicat es considera blau
	 * 
	 */
	public boolean esBlau(float[]hsv){
		boolean isColor = false;
		if(hsv[0] <= 230 && hsv[0] >=175 && hsv[1]>0.30){
			isColor=true;
		}		
		return isColor;
	}	
	
	
	/*
	 * Funció per comprobar si el color indicat es considera vermell
	 * 
	 */
	public boolean esVermell(float[]hsv){
		boolean isColor = false;
		if(((hsv[0] <= 15 && hsv[0] > 0) || hsv[0] >= 335) && hsv[1] > 0.7 && hsv[2] > 0.5){ 
			isColor=true;
		}		
		return isColor;
	}
	
	/*
	 * Funció per comprobar si el color indicat es considera verd
	 * 
	 */
	public boolean esVerd(float[]hsv){
		boolean isColor = false;
		if(hsv[0] <= 170 && hsv[0] >=90 && hsv[1]>0.20){
			isColor=true;
		}		
		return isColor;
	}	

	//botó de menú
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.colors, menu);
		return true;
	}
	

	/*
	 * Funció per tractar la resposta de la Activity que engega la camera del dispositiu
	 * 
	 */

    protected void onActivityResult(int requestCode, int resultCode, Intent data){
        if(resultCode == RESULT_OK){
            if(requestCode == 99){
                final boolean isCamera;
                if(data == null){
                    isCamera = true;
                }
                else{
                    final String action = data.getAction();
                    if(action == null){
                        isCamera = false;
                    }
                    else{
                    	isCamera = MediaStore.ACTION_IMAGE_CAPTURE.equals(data.getAction());	
                    }
                }                
            }
        }
    }    
    
    /*
	 * Funció per crear un directori on guardar la fotografia feta
	 * 
	 */
    private void creaDirectoriFotos(){
        directori = new File(Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DCIM), "MyDir");
        if (directori.exists()){
            directori.mkdir();
        }
    }
    
    /*
	 * Funció que gestiona l'obtencio de la imatge.
	 * Gestiona el selector per escollir si vols fer-la amb la camara de serie,
	 * altres aplicacions de camera o agafarla de la galeria. 
	 * 
	 */

	private void intentObrirImatge() {

		// Uri per guardar la imatge de la camera    		
		File arrel = new File(Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DCIM) , "MyDir");
		arrel.mkdir();
	
		final File directoriImatgeAMemoria = new File(arrel, "p1.jpg");
		uriFitxerSortida = Uri.fromFile(directoriImatgeAMemoria);
		
		// Gestio de la opcio  per captar la imatge amb la camera propia.  
		final List<Intent> intentsCamera = new ArrayList<Intent>();
		final Intent intentCaptura = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
		final PackageManager packageManager = getPackageManager();
		final List<ResolveInfo> listCam = packageManager.queryIntentActivities(intentCaptura, 0);
		for(ResolveInfo res : listCam) {
		    final String packageName = res.activityInfo.packageName;
		    final Intent intent = new Intent(intentCaptura);
		    intent.setComponent(new ComponentName(res.activityInfo.packageName, res.activityInfo.name));
		    intent.setPackage(packageName);
		    intent.putExtra(MediaStore.EXTRA_OUTPUT, uriFitxerSortida);
		    intentsCamera.add(intent);
		}
	
		// Gestio de la opcio per captar la imatge d'altres fonts. 
		final Intent intentGaleria = new Intent();
		intentGaleria.setType("image/*");
		intentGaleria.setAction(Intent.ACTION_GET_CONTENT);
	    
		// configuracio del selector de opcions (camera, altres cameres, galeria)
		final Intent intentSelector = Intent.createChooser(intentGaleria, "Selecciona la font: \nSelect Source:");
		intentSelector.putExtra(Intent.EXTRA_INITIAL_INTENTS, intentsCamera.toArray(new Parcelable[]{}));
		    
		startActivityForResult(intentSelector, 99);
		    	    
		}
}
